import java.io.*;
import java.util.*;

public class PomocnikGry {
  private static final String alfabet = "abcdefg";
  private int dlugoscPlanszy = 7;
  private int wielkoscPlanszy = 49;
  private int [] plansza = new int[wielkoscPlanszy];
  private int iloscPortali = 0;
  
  public String pobierzDaneWejsciowe(String komunikat) {
    String daneWejsciowe = null;
    System.out.print(komunikat + "  ");
    try {
       BufferedReader is = new BufferedReader(
	       new InputStreamReader(System.in));
       daneWejsciowe = is.readLine();
       if (daneWejsciowe.length() == 0 )  return null; 
    } catch (IOException e) {
      System.out.println("IOException: " + e);
    }
    return daneWejsciowe.toLowerCase();
  }
  
  public ArrayList rozmiescPortal(int wielkoscPortalu) {
    ArrayList zajetePola = new ArrayList();
    String [] wspolrzedneLnc = new String [wielkoscPortalu]; // zawiera wsprzdne zapisane jako 'f6'
    String pomoc = null;                                // pomocniczy acuch znakw
    int [] wspolrzedne = new int[wielkoscPortalu];      // biece proponowane wsprzdne
    int prob = 0;                                       // licznik iloci prb
    boolean powodzenie = false;                         // flaga = czy znaleziono dobre miejsce
    int polozenie = 0;                                  // biece miejsce pocztkowe
    
    iloscPortali++;                                     // n-ty portal do rozmieszczenia
    int inkr = 1;                                       // okrelenie przyrostu w poziomie
    if ((iloscPortali % 2) == 1) {                      // jeli nieparzysty portal (rozmieszczany w pionie)
      inkr = dlugoscPlanszy;                            // okrelenie przyrostu w pionie
    }

    while (!powodzenie & prob++ < 200 ) {                 // gwna ptla poszukiwania
	    polozenie = (int) (Math.random() * wielkoscPlanszy);  // wybr losowego punktu pocztkowego
      //System.out.print(" sprawd " + location);
	    int x = 0;                                          // n-ty fragment rozmieszczanego portalu
      powodzenie = true;                                  // zakadamy, e si udao 
      while (powodzenie && x < wielkoscPortalu) {         // szukamy ssiadujcych pustych pl planszy
        if (plansza[polozenie] == 0) {                    // jeli jeszcze nie zajte
          wspolrzedne[x++] = polozenie;                   // zapisujemy miejsce
          polozenie += inkr;                              // sprawdzamy 'nastpne' ssiadujce pole
          if (polozenie >= wielkoscPlanszy){              // poza zakresem - 'd' planszy
            powodzenie = false;                           // niepowodzenie
          }
          if (x>0 & (polozenie % dlugoscPlanszy == 0)) {  // poza zakresem - prawa krawd planszy
            powodzenie = false;                           // niepowodzenie
          }
        } else {                                          // znalezione pole ju jest zajte
          // System.out.print(" ju zajte " + location);
          powodzenie = false;                             // niepowodzenie
        }
      }
    }                                                     // koniec while
    
    int x = 0;                                            // zamieniamy na wsprzdne 
    int wiersz = 0;
    int kolumna = 0;
    while (x < wielkoscPortalu) {
      plansza[wspolrzedne[x]] = 1;                        // zaznaczamy pole planszy jako zajte
      wiersz = (int) (wspolrzedne[x] / dlugoscPlanszy);   // okrelenie wiersza
      kolumna = wspolrzedne[x] % dlugoscPlanszy;          // pobranie liczby okrelajcej kolumn
      pomoc = String.valueOf(alfabet.charAt(kolumna));    // konwersja do postaci alfanumerycznej
      
      zajetePola.add(pomoc.concat(Integer.toString(wiersz)));
      x++;
    }
     System.out.println(zajetePola);
    
    return zajetePola;
  }
}